/* Zadatak 2B:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija klokan iz (a). */

int klokan(int n, char B[], int hop)
{
    int i, broj_nagrada = 0;

        /* Odmah provjerimo je li n djeljiv s hop.
           Ako nije, zadnji skok ne moze biti na polje s indeksom n
           pa vratimo -1 (neuspjeh). */
    if (n % hop != 0) return -1;

        /* Petlja za skokove, svaki duljine hop.
           Nakon skoka, klokan je na polju s indeksom i. */
    for (i = hop; i <= n; i += hop) {

            /* Provjera za lose polje (neuspjeh). */
        if (B[i] == 't') return -1;

            /* Provjera za polje s nagradom. */
        if (B[i] == 'n') ++broj_nagrada;
    }

        /* Ako prodjemo kroz cijelu petlju, prolaz je uspjesan.
           Vrati broj prikupljenih nagrada. */
    return broj_nagrada;
}

/* ========================================================================= */

    /* Uociti da hopovi u polju h strogo rastu, pa se najveci hop
       dobije kao zadnji hop za koji skupimo bar min nagrada (ako ga ima).
       Za pocetne (male) hopove mozemo dobiti neuspjeh, no za zadnji
       hop (h[m] = n) sigurno imamo uspjeh, jer je B[n] != 't'. */

    /* Funkcija minnagrada iz (b) - jedno binarno pretrazivanje.
       Jednim binarnim trazenjem preskacemo eventualne neuspjesne hopove
       (na pocetku polja h) i trazimo najveci uspjesni hop s bar min nagrada
       (ako ga ima). */

int minnagrada(int n, int m, int min, char B[], int h[])
{
    int max_hop = -1;

        /* Trazimo u granicama indeksa [l, d], a s je srednji. */
    int l = 0, d = m, s;
        /* Trenutni hop = h[s] i pripadni broj nagrada. */
    int hop, broj_nagrada;

        /* Trazimo sve dok je l <= d, tj. skup preostalih indeksa
           za pretragu je neprazan. */
    while (l <= d) {
            /* Indeks na "pola" preostalog intervala.
               Uociti da za l = d ili l + 1 = d (tj. imamo 1 ili 2
               preostala indeksa u intervalu), dobijemo s = l. */
        s = (l + d) / 2;

            /* Pripadni hop = h[s]. */
        hop = h[s];
            /* Pripadni broj nagrada - poziv funkcije iz (a). */
        broj_nagrada = klokan(n, B, hop);

            /* Ako je prolaz neuspjesan, dizemo l na s + 1.
               Naime, za sve hopove manje od ovog (ispred indeksa s),
               isto imamo neuspjeh. */
        if (broj_nagrada == -1) {
            l = s + 1;
            continue;    /* Zato da ispod nema else, jer se teze cita. */
        }

            /* Ovdje je prolaz uspjesan za trenutni hop. Ako je
               broj_nagrada < min, onda to isto (zbog djeljivosti) vrijedi
               i za sve vece hopove (iza indeksa s). Smanji d na s - 1. */
        if (broj_nagrada < min) {
            d = s - 1;
            continue;    /* Zato da ispod nema else, jer se teze cita. */
        }

            /* Ovdje je broj_nagrada >= min. Za sve indekse ispred s
               (tj. za manje hopove) dobivamo ili neuspjeh, ili jos veci
               broj nagrada (>= min).
               Dakle, trazeni najveci hop je veci ili jednak od ovog. */

            /* Ako ZAPAMTIMO ovaj hop h[s] kao najveci (do sada)
               koji daje bar min nagrada, onda nam on vise NE treba.
               Zato mozemo povecati l na s + 1 (sigurno raste za bar 1)
               i vise nema opasnosti od beskonacne petlje!
                 Uociti da u preostalom intervalu vise ne mora postojati
               hop koji daje bar min nagrada, ali to nije bitno. */
        max_hop = hop;
        l = s + 1;
    }

    return max_hop;
}

/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
        /* Polje B s 25 elemenata za demo. */
    int n = 24;
    char B[25] = {
        'z',    /* Pocetno polje klokana. */
        'z', 'z', 't', 't', 'z', 'n',  'z', 'z', 'n', 'z', 'z', 'n',
        'z', 'z', 'n', 'z', 'z', 'n',  'z', 'z', 'n', 'z', 'z', 'n'
      };

        /* Polje hopova h za demo. */
    int m = 4;
    int h[5] = { 1, 2, 6, 12, 24 };

        /* Ostale varijable za demo. */
    int hop, broj_nagrada, min;

        /* Petlja za test funkcije iz (a) - razni hopovi. */
    for (hop = 1; hop <= n; ++hop) {

            /* Poziv funkcije klokan iz (a). */
        broj_nagrada = klokan(n, B, hop);

            /* Ispis rezultata za dani hop. */
        printf(" hop = %2d,  ", hop);
        if (broj_nagrada == -1)
            printf("neuspjeh\n");
        else
            printf("broj nagrada = %2d\n", broj_nagrada);
    }

    printf("\n");

        /* Petlja za test funkcije iz (b), razni min. */
    for (min = 5; min >= 1; --min) {

            /* Poziv funkcije minnagrada iz (b). */
        hop = minnagrada(n, m, min, B, h);
        printf(" min = %2d,  ", min);
        if (hop == -1)
            printf("nema takvog hopa\n");
        else
            printf("najveci hop = %2d\n", hop);
    }

    return 0;
}
