/* Zadatak 2C:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija igrac iz (a). */

int igrac(int n, char C[], int preskok)
{
    int i, broj_zlatnika = 0;

        /* Odmah provjerimo je li n djeljiv s preskokom.
           Ako nije, zadnji skok ne moze biti na polje s indeksom n
           pa vratimo -1 (neuspjeh). */
    if (n % preskok != 0) return -1;

        /* Petlja za skokove, svaki duljine preskok.
           Nakon skoka, igrac je na polju s indeksom i. */
    for (i = preskok; i <= n; i += preskok) {

            /* Provjera za lose polje (neuspjeh). */
        if (C[i] == 'k') return -1;

            /* Provjera za polje sa zlatnikom. */
        if (C[i] == 'z') ++broj_zlatnika;
    }

        /* Ako prodjemo kroz cijelu petlju, prolaz je uspjesan.
           Vrati broj prikupljenih zlatnika. */
    return broj_zlatnika;
}

/* ========================================================================= */

    /* Uociti da preskoci u polju p strogo rastu, pa se najveci preskok
       dobije kao zadnji preskok za koji skupimo bar min zlatnika (ako ga ima).
       Za pocetne (male) preskoke mozemo dobiti neuspjeh, no za zadnji
       preskok (p[m] = n) sigurno imamo uspjeh, jer je C[n] != 'k'. */

    /* Funkcija minzlato iz (b) - jedno binarno pretrazivanje.
       Jednim binarnim trazenjem preskacemo eventualne neuspjesne preskoke
       (na pocetku polja p) i trazimo najveci uspjesni preskok s bar min
       zlatnika (ako ga ima). */

int minzlato(int n, int m, int min, char C[], int p[])
{
    int max_preskok = -1;

        /* Trazimo u granicama indeksa [l, d], a s je srednji. */
    int l = 0, d = m, s;
        /* Trenutni preskok = p[s] i pripadni broj zlatnika. */
    int preskok, broj_zlatnika;

        /* Trazimo sve dok je l <= d, tj. skup preostalih indeksa
           za pretragu je neprazan. */
    while (l <= d) {
            /* Indeks na "pola" preostalog intervala.
               Uociti da za l = d ili l + 1 = d (tj. imamo 1 ili 2
               preostala indeksa u intervalu), dobijemo s = l. */
        s = (l + d) / 2;

            /* Pripadni preskok = p[s]. */
        preskok = p[s];
            /* Pripadni broj zlatnika - poziv funkcije iz (a). */
        broj_zlatnika = igrac(n, C, preskok);

            /* Ako je prolaz neuspjesan, dizemo l na s + 1.
               Naime, za sve preskoke manje od ovog (ispred indeksa s),
               isto imamo neuspjeh. */
        if (broj_zlatnika == -1) {
            l = s + 1;
            continue;    /* Zato da ispod nema else, jer se teze cita. */
        }

            /* Ovdje je prolaz uspjesan za trenutni preskok. Ako je
               broj_zlatnika < min, onda to isto (zbog djeljivosti) vrijedi
               i za sve vece preskoke (iza indeksa s). Smanji d na s - 1. */
        if (broj_zlatnika < min) {
            d = s - 1;
            continue;    /* Zato da ispod nema else, jer se teze cita. */
        }

            /* Ovdje je broj_zlatnika >= min. Za sve indekse ispred s
               (tj. za manje preskoke) dobivamo ili neuspjeh, ili jos veci
               broj zlatnika (>= min).
               Dakle, trazeni najveci preskok je veci ili jednak od ovog. */

            /* Ako ZAPAMTIMO ovaj preskok p[s] kao najveci (do sada)
               koji daje bar min zlatnika, onda nam on vise NE treba.
               Zato mozemo povecati l na s + 1 (sigurno raste za bar 1)
               i vise nema opasnosti od beskonacne petlje!
                 Uociti da u preostalom intervalu vise ne mora postojati
               preskok koji daje bar min zlatnika, ali to nije bitno. */
        max_preskok = preskok;
        l = s + 1;
    }

    return max_preskok;
}

/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
        /* Polje C s 25 elemenata za demo. */
    int n = 24;
    char C[25] = {
        'p',    /* Pocetno polje igraca. */
        'p', 'p', 'k', 'k', 'p', 'z',  'p', 'p', 'z', 'p', 'p', 'z',
        'p', 'p', 'z', 'p', 'p', 'z',  'p', 'p', 'z', 'p', 'p', 'z'
      };

        /* Polje preskoka p za demo. */
    int m = 4;
    int p[5] = { 1, 2, 6, 12, 24 };

        /* Ostale varijable za demo. */
    int preskok, broj_zlatnika, min;

        /* Petlja za test funkcije iz (a) - razni preskoci. */
    for (preskok = 1; preskok <= n; ++preskok) {

            /* Poziv funkcije igrac iz (a). */
        broj_zlatnika = igrac(n, C, preskok);

            /* Ispis rezultata za dani preskok. */
        printf(" preskok = %2d,  ", preskok);
        if (broj_zlatnika == -1)
            printf("neuspjeh\n");
        else
            printf("broj zlatnika = %2d\n", broj_zlatnika);
    }

    printf("\n");

        /* Petlja za test funkcije iz (b), razni min. */
    for (min = 5; min >= 1; --min) {

            /* Poziv funkcije minzlato iz (b). */
        preskok = minzlato(n, m, min, C, p);
        printf(" min = %2d,  ", min);
        if (preskok == -1)
            printf("nema takvog preskoka\n");
        else
            printf("najveci preskok = %2d\n", preskok);
    }

    return 0;
}
