/* Zadatak 3B:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija za racunanje koeficijenata c_j.
       Pozitivni najmanji zajednicki visekratnik brojeva a i b. */

int visekratnik(int a, int b)
{
    int ostatak, prod;

        /* Apsolutne vrijednosti od a i b. */
    if (a < 0) a = -a;
    if (b < 0) b = -b;
    prod = a * b;    /* Za visekratnik iz mjere. */

        /* Euklidov algoritam za najvecu zajednicku mjeru. */
    while (b > 0) {
        ostatak = a % b;
        a = b;
        b = ostatak;
    }
        /* Vrati visekratnik. */
    return prod / a;
}

/* ========================================================================= */

    /* Funkcija iz zadatka = dvostruki Hornerov algoritam. */

    /* Do algoritma dolazimo na sljedeci nacin.
       Trazenu vrijednost Q(x) pisemo u obliku
           Q(x) = sum_j sum_i  d_j(i) * x^(i + j)
                = sum_j ( sum_i d_j(i) * x^i ) * x^j.
       Unutarnju sumu oznacimo s Q_j(x), pa je
           Q(x) = sum_j Q_j(x) * x^j  (vanjski Horner, petlja po j)
       a koeficijenti Q_j(x) su
           Q_j(x) = sum_i d_j(i) * x^i  (unutranji Horner, petlja po i),
       pri cemu c_j izracunamo jednom, PRIJE petlje po i.
    */

double Horner(int a[], int b[], int n, double x)
{
    int i, j, c_j;
    double d_ji, q_j, q = 0.0;

        /* Vanjska petlja po j je silazna - Horner za Q(x). */
    for (j = n - 1; j >= 0; --j) {

            /* Izracunaj c_j jednom. */
        c_j = visekratnik(a[j], b[j]);

            /* Inicijaliziraj q_j na 0. */
        q_j = 0.0;

            /* Unutarnja petlja po i je silazna - Horner za Q_j(x). */
        for (i = n - 1; i >= 0; --i) {
                /* Koeficijent d_ji = d_j(i) u tipu double! */
            d_ji = (double) (c_j - b[i]) / a[i];
                /* Horner za q_j = Q_j(x). */
            q_j = q_j * x + d_ji;
        }

            /* Horner za Q(x). */
        q = q * x + q_j;
    }

    return q;
}

/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
        /* Polja a i b s 5 elemenata za demo. */
    int n = 5;
    int a[5] = {  1, -2,  3, -4,  5 };
    int b[5] = { 10,  8,  6,  4,  2 };

    double x = 1.0, p;

        /* Poziv funkcije za P(x). */
    p = Horner(a, b, n, x);
    printf(" x = %g, P(x) = %g\n", x, p);

    return 0;
}
