/* Zadatak 3C:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija za racunanje koeficijenata c_j.
       Pozitivna najveca zajednicka mjera brojeva a i b. */

int mjera(int a, int b)
{
    int ostatak;

        /* Apsolutne vrijednosti od a i b. */
    if (a < 0) a = -a;
    if (b < 0) b = -b;

        /* Euklidov algoritam za najvecu zajednicku mjeru. */
    while (b > 0) {
        ostatak = a % b;
        a = b;
        b = ostatak;
    }

        /* Vrati mjeru. */
    return a;
}

/* ========================================================================= */

    /* Funkcija iz zadatka = dvostruki Hornerov algoritam. */

    /* Do algoritma dolazimo na sljedeci nacin.
       Trazenu vrijednost R(x) pisemo u obliku
           R(x) = sum_j sum_i  d_j(i) * x^(i + j)
                = sum_j ( sum_i d_j(i) * x^i ) * x^j.
       Unutarnju sumu oznacimo s R_j(x), pa je
           R(x) = sum_j R_j(x) * x^j  (vanjski Horner, petlja po j)
       a koeficijenti R_j(x) su
           R_j(x) = sum_i d_j(i) * x^i  (unutranji Horner, petlja po i),
       pri cemu c_j izracunamo jednom, PRIJE petlje po i.
    */

double Horner(int a[], int b[], int n, double x)
{
    int i, j, c_j;
    double d_ji, r_j, r = 0.0;

        /* Vanjska petlja po j je silazna - Horner za R(x). */
    for (j = n - 1; j >= 0; --j) {

            /* Izracunaj c_j jednom. */
        c_j = mjera(a[j], b[j]);

            /* Inicijaliziraj r_j na 0. */
        r_j = 0.0;

            /* Unutarnja petlja po i je silazna - Horner za R_j(x). */
        for (i = n - 1; i >= 0; --i) {
                /* Koeficijent d_ji = d_j(i) u tipu double! */
            d_ji = (double) (b[i] + c_j) / a[i];
                /* Horner za r_j = R_j(x). */
            r_j = r_j * x + d_ji;
        }

            /* Horner za R(x). */
        r = r * x + r_j;
    }

    return r;
}

/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
        /* Polja a i b s 5 elemenata za demo. */
    int n = 5;
    int a[5] = {  1, -2,  3, -4,  5 };
    int b[5] = { 10,  8,  6,  4,  2 };

    double x = 1.0, p;

        /* Poziv funkcije za P(x). */
    p = Horner(a, b, n, x);
    printf(" x = %g, P(x) = %g\n", x, p);

    return 0;
}
